/* TagParser.java created by Administrator on Sat 24-Jun-2000 */

import com.webobjects.foundation.*;
import com.webobjects.appserver.*;
import com.webobjects.eocontrol.*;
import java.util.*;


public class TagParser extends Object {
    protected String string;
    protected int index;

    public TagParser(String value) {
        setString(value);
    }

    public String string() {
        return string;
    }

    public void setString(String value) {
        string = value;
        index = 0;
    }

    public void replaceTag(Tag tag, String newtag) {
        // needs to do more - copy other attributes across from Tag
        setString(string.substring(0, tag.begin()) + newtag + string.substring(tag.end()));
    }

    public Tag getNextTag(String name) {
        Tag tagDict = getNextTag();
        while (tagDict != null) {
            if (tagDict.attribute("tag").equalsIgnoreCase(name))
                return tagDict;
            tagDict = getNextTag();
        }
        return null;
    }

    public Tag getNextTag() {
        NSMutableDictionary tagDict = new NSMutableDictionary();
        Tag tagValue = new Tag();
        String tag = "";
        int i, j;

        i = string.indexOf('<', index);
        if (i == -1) return null;
        j = string.indexOf('>', i);
        if (j == -1) return null;
        tag = string.substring(i + 1, j);

        StringTokenizer tok = new StringTokenizer(tag);

        while(tok.hasMoreElements()) {
            String token = tok.nextToken();
            if (tagDict.count() == 0) {	// first token; i.e. the tag
                tagDict.setObjectForKey(token, "tag");
            } else {
                int k = token.indexOf('=');
                if (k == -1) {	// not found
                    tagDict.setObjectForKey("", token);
                } else {
                    tagDict.setObjectForKey(token.substring(k+1), token.substring(0, k));
                }
            }
        }
        // System.out.println("tagDict: " + tagDict);
        
        index = j + 1;
        tagValue.setAttributes(tagDict);
        tagValue.setBegin(i);
        tagValue.setEnd(j + 1);
        return tagValue;
    }

}
