// Keyword.java
// Created on Sun Jun 18 12:59:42  2000 by Apple EOModeler Version 378.3


import com.webobjects.foundation.*;
import com.webobjects.eocontrol.*;
import com.webobjects.eoaccess.*;
import java.util.*;
import java.math.BigDecimal;

public class Keyword extends _Keyword {

    public Keyword() {
        super();
    }
	
	public static NSArray allKeywords() {
		return EOUtilities.objectsWithFetchSpecificationAndBindings(new EOEditingContext(), "Keyword", "AllKeywords", null);
	}

	public String key() {
		NSDictionary keyDict = EOUtilities.primaryKeyForObject(editingContext(), this);
		Enumeration i = keyDict.objectEnumerator();
		String key = "";
		while (i.hasMoreElements()) {
			Object o = i.nextElement();
			key += o.toString();
		}
		return key;
	}
	
	public static Keyword keywordWithKey(String key) {
		Integer keyNum;
		try {
			keyNum = new Integer(key);
		} catch (NumberFormatException ex) {
			NSLog.debug.appendln("NumberFormatException on Keyword key: " + key);
			return null;
		}
		return (Keyword)EOUtilities.objectWithPrimaryKeyValue(new EOEditingContext(), "Keyword", keyNum);
	}
	
}
