// Para.java
// Created on Sun Jun 18 18:25:04  2000 by Apple EOModeler Version 378.3


import com.webobjects.foundation.*;
import com.webobjects.eocontrol.*;
import com.webobjects.eoaccess.*;
import java.util.*;
import java.math.BigDecimal;

public class Para extends _Para {
	
	protected String replace(String string, String old, String replace) {
		NSArray tmpArray = NSArray.componentsSeparatedByString(string, old);
        return tmpArray.componentsJoinedByString(replace);
	}

    public String body() {
		String tmpStr;
        // should escape &, < and >
        tmpStr = "<p>" + replace(super.body(), "\n\n", "<p></p>") + "</p>";
        tmpStr = replace(tmpStr, "\n", "<br/>");
        return tmpStr;
    }

    public String rawBody() {
        willRead();
        return super.body();
    }

    public String page() {
        if (super.page() != null) return super.page();
        if (article() != null && article().category() != null && article().category().valueForKey("paraPage") != null)
            return (String)article().category().valueForKey("paraPage");
        return super.page();
    }

    public Image imageForName(String name) {
        Enumeration index = images().objectEnumerator();
        Image image;
        while (index.hasMoreElements()) {
            image = (Image)index.nextElement();
            if (image.name() != null && image.name().equalsIgnoreCase(name))
                return image;
        }
        return null;
    }

	public String key() {
		NSDictionary keyDict = EOUtilities.primaryKeyForObject(editingContext(), this);
		Enumeration i = keyDict.objectEnumerator();
		String key = "";
		while (i.hasMoreElements()) {
			Object o = i.nextElement();
			key += o.toString();
		}
		return key;
	}
	
	public static Para paraWithKey(String key) {
		Integer keyNum;
		try {
			keyNum = new Integer(key);
		} catch (NumberFormatException ex) {
			NSLog.debug.appendln("NumberFormatException on Para key: " + key);
			return null;
		}
		return (Para)EOUtilities.objectWithPrimaryKeyValue(new EOEditingContext(), "Para", keyNum);
	}

}
